<template>
  <div>
    <Ariane
      type="breadcrumb trunk"
      :breadcrumbs="breadcrumbs"
      :params="params"
    />
    <div class="trunk content">
      <header class="block-header">
        <h2 class="block-title">
          {{ $t('publishers.title') }}
        </h2>
      </header>
      <div class="list--grid trunc">
        <div
          v-for="publisher of displayedList"
          :key="publisher.id"
          class="grid-col-1 grid-item"
        >
          <NuxtLink
            :prefetch="false"
            :to="
              localePath({
                name: 'publisher-id',
                params: { id: `${publisher.slug}-${publisher.id}` }
              })
            "
          >
            <span
              :style="{
                'background-image': `url(${$config.izneoUrl}/${$i18n.locale}/images/publisher/${publisher.id}-w130.jpg)`
              }"
            ></span>
          </NuxtLink>
        </div>
      </div>

      <Loader :display="isLoading" />
      <Pagination
        v-if="publisherCount > paginationLimit"
        :current-page="currentPage"
        :total-page="totalPage"
        :items-per-page="paginationLimit"
        @updatePage="updatePage"
      />
    </div>
  </div>
</template>

<script>
import Ariane from '~/components/ui/Ariane'
import Pagination from '~/components/ui/Pagination'
import Loader from '~/components/ui/Loader'

export default {
  name: 'Publishers',
  components: {
    Ariane,
    Pagination,
    Loader
  },

  async fetch() {
    await this.loadPublishers(this.currentPage)
  },

  data() {
    return {
      isLoading: false,
      title: this.$t('breadcrumb.publishers'),
      breadcrumbs: [
        this.$t('breadcrumb.home'),
        this.$t('breadcrumb.publishers')
      ],
      params: [`/${this.$i18n.locale}/`, ''],
      publishers: { pages: [] },

      publisherCount: 0,
      currentPage: 1,
      paginationLimit: 24,
      totalPage: undefined,
      displayedList: []
    }
  },

  methods: {
    async loadPublishers(page) {
      this.isLoading = true
      try {
        const offset = (page - 1) * this.paginationLimit

        const data = await this.$api.publishers(offset)
        if (!data) return

        if (undefined === this.totalPage) {
          this.publisherCount = data.count
          this.totalPage = Math.ceil(this.publisherCount / this.paginationLimit)
        }

        this.publishers.pages[page - 1] = data.publishers

        await this.setDisplayed()
      } finally {
        this.isLoading = false
      }
    },

    updatePage(currentPage) {
      this.currentPage = currentPage

      this.setDisplayed()
    },

    async setDisplayed() {
      if (!this.publishers.pages[this.currentPage - 1])
        await this.loadPublishers(this.currentPage)

      this.displayedList = this.publishers.pages[this.currentPage - 1]
    }
  },

  head() {
    return {
      titleTemplate: this.title
    }
  }
}
</script>

<style lang="scss" scoped>
.block-header {
  margin-top: 30px;

  .block-title {
    line-height: 1.39;
    font-family: DINCond-Regular, sans-serif;
    font-weight: 400;
    text-transform: uppercase;
    font-size: 2.57143rem;
  }
}
.publisher-wrapper-logo {
  border: 1px solid #ebebeb;
  height: 130px;
  margin-bottom: 15px;
  padding: 4px;
}

.list--grid {
  display: flex;
  justify-content: space-between;
  align-items: center;
  flex-wrap: wrap;

  .grid-col-1 {
    width: 12.5%;
  }

  .grid-item {
    border: 1px solid #ebebeb;
    height: 130px;
    padding: 4px;
    margin: 22px 25px 22px 0;
    min-width: 130px;

    span {
      background-position: center center;
      background-repeat: no-repeat;
      background-size: contain;
      display: block;
      height: 100%;
    }
  }
}
</style>
